<!DOCTYPE html>
<html lang="" xml:lang="">
  <head>
    <title>Collection and Analysis of Digital Behavioral Data</title>
    <meta charset="utf-8" />
    <meta name="author" content="Long Nguyen, Zaza Zindel" />
    <meta name="date" content="2023-04-20" />
    <script src="data-collection-1_files/header-attrs/header-attrs.js"></script>
    <script src="data-collection-1_files/xaringanExtra-progressBar/progress-bar.js"></script>
    <link href="data-collection-1_files/panelset/panelset.css" rel="stylesheet" />
    <script src="data-collection-1_files/panelset/panelset.js"></script>
    <link href="data-collection-1_files/xaringanExtra-extra-styles/xaringanExtra-extra-styles.css" rel="stylesheet" />
    <link rel="stylesheet" href="assets/xaringan-unibi.css" type="text/css" />
    <link rel="stylesheet" href="assets/width.css" type="text/css" />
    <link rel="stylesheet" href="https://rsms.me/inter/inter.css" type="text/css" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@xz/fonts@1/serve/ibm-plex-mono.min.css" type="text/css" />
  </head>
  <body>
    <textarea id="source">
class: left, bottom, title-slide

.title[
# Collection and Analysis of<br>Digital Behavioral Data
]
.subtitle[
## Data Collection I (Introduction to R)
]
.author[
### Long Nguyen, Zaza Zindel
]
.date[
### 20 April 2023
]

---




<div>
<style type="text/css">.xaringan-extra-logo {
width: 200px;
height: 128px;
z-index: 0;
background-image: url(assets/faksoz.png);
background-size: contain;
background-repeat: no-repeat;
position: absolute;
top:1em;right:.5em;
}
</style>
<script>(function () {
  let tries = 0
  function addLogo () {
    if (typeof slideshow === 'undefined') {
      tries += 1
      if (tries < 10) {
        setTimeout(addLogo, 100)
      }
    } else {
      document.querySelectorAll('.remark-slide-content')
        .forEach(function (slide) {
          const logo = document.createElement('div')
          logo.classList = 'xaringan-extra-logo'
          logo.href = null
          slide.appendChild(logo)
        })
    }
  }
  document.addEventListener('DOMContentLoaded', addLogo)
})()</script>
</div><style>.xe__progress-bar__container {
  bottom:0;
  opacity: 1;
  position:absolute;
  right:0;
  left: 0;
}
.xe__progress-bar {
  height: 5px;
  background-color: #bfd02f;
  width: calc(var(--slide-current) / var(--slide-total) * 100%);
}
.remark-visible .xe__progress-bar {
  animation: xe__progress-bar__wipe 200ms forwards;
  animation-timing-function: cubic-bezier(.86,0,.07,1);
}
@keyframes xe__progress-bar__wipe {
  0% { width: calc(var(--slide-previous) / var(--slide-total) * 100%); }
  100% { width: calc(var(--slide-current) / var(--slide-total) * 100%); }
}</style>

&lt;style type="text/css"&gt;
pre {
  overflow: auto;
}
&lt;/style&gt;

## Outline

- Getting familiar with R and RStudio&lt;br&gt;&lt;br&gt;
- R programming basics&lt;br&gt;&lt;br&gt;
- Working with data using **tidyverse**&lt;br&gt;&lt;br&gt;

---

count: false
 
### Motivating example:&lt;br&gt;Number of messages per day in a WhatsApp chat
.panel1-wa-example-auto[

```r
*library(tidyverse)
```
]
 
.panel2-wa-example-auto[

]

---
count: false
 
### Motivating example:&lt;br&gt;Number of messages per day in a WhatsApp chat
.panel1-wa-example-auto[

```r
library(tidyverse)

*read_csv("https://long_nguyen.pages.ub.uni-bielefeld.de/dbd-ss23/data/wa-chat.csv")
```
]
 
.panel2-wa-example-auto[

```
# A tibble: 2,192 × 8
   person    year month   day  hour minute message                      n_emojis
   &lt;chr&gt;    &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt; &lt;chr&gt;                           &lt;dbl&gt;
 1 Long      2018    11    18    17     52 "They tried to make a diamo…        0
 2 Long      2018    11    18    17     53 "https://www.why-does-norwa…        0
 3 Person 2  2018    11    18    18     51 "Why do pirates not know th…        1
 4 Person 2  2018    11    20    17      6 "Some people say that I nev…        0
 5 Person 2  2018    11    20    17      7 "Why did Sweden start paint…        0
 6 Long      2018    11    20    17      7 "It takes guts to be an org…        1
 7 Long      2018    11    22    12      5 "What kind of magic do cows…        0
 8 Person 2  2018    11    22    12     14 "What has a bed that you ca…        0
 9 Person 2  2018    11    22    12     14 "This is my step ladder. I …        0
10 Long      2018    11    22    12     18 "It takes guts to be an org…        0
# ℹ 2,182 more rows
```
]

---
count: false
 
### Motivating example:&lt;br&gt;Number of messages per day in a WhatsApp chat
.panel1-wa-example-auto[

```r
library(tidyverse)

read_csv("https://long_nguyen.pages.ub.uni-bielefeld.de/dbd-ss23/data/wa-chat.csv") |&gt;
* filter(year == 2018)
```
]
 
.panel2-wa-example-auto[

```
# A tibble: 60 × 8
   person    year month   day  hour minute message                      n_emojis
   &lt;chr&gt;    &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt; &lt;chr&gt;                           &lt;dbl&gt;
 1 Long      2018    11    18    17     52 "They tried to make a diamo…        0
 2 Long      2018    11    18    17     53 "https://www.why-does-norwa…        0
 3 Person 2  2018    11    18    18     51 "Why do pirates not know th…        1
 4 Person 2  2018    11    20    17      6 "Some people say that I nev…        0
 5 Person 2  2018    11    20    17      7 "Why did Sweden start paint…        0
 6 Long      2018    11    20    17      7 "It takes guts to be an org…        1
 7 Long      2018    11    22    12      5 "What kind of magic do cows…        0
 8 Person 2  2018    11    22    12     14 "What has a bed that you ca…        0
 9 Person 2  2018    11    22    12     14 "This is my step ladder. I …        0
10 Long      2018    11    22    12     18 "It takes guts to be an org…        0
# ℹ 50 more rows
```
]

---
count: false
 
### Motivating example:&lt;br&gt;Number of messages per day in a WhatsApp chat
.panel1-wa-example-auto[

```r
library(tidyverse)

read_csv("https://long_nguyen.pages.ub.uni-bielefeld.de/dbd-ss23/data/wa-chat.csv") |&gt;
  filter(year == 2018) |&gt;
* mutate(date = as.Date(
*   paste(year, month, day, sep = "-")
* ))
```
]
 
.panel2-wa-example-auto[

```
# A tibble: 60 × 9
   person    year month   day  hour minute message           n_emojis date      
   &lt;chr&gt;    &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt; &lt;chr&gt;                &lt;dbl&gt; &lt;date&gt;    
 1 Long      2018    11    18    17     52 "They tried to m…        0 2018-11-18
 2 Long      2018    11    18    17     53 "https://www.why…        0 2018-11-18
 3 Person 2  2018    11    18    18     51 "Why do pirates …        1 2018-11-18
 4 Person 2  2018    11    20    17      6 "Some people say…        0 2018-11-20
 5 Person 2  2018    11    20    17      7 "Why did Sweden …        0 2018-11-20
 6 Long      2018    11    20    17      7 "It takes guts t…        1 2018-11-20
 7 Long      2018    11    22    12      5 "What kind of ma…        0 2018-11-22
 8 Person 2  2018    11    22    12     14 "What has a bed …        0 2018-11-22
 9 Person 2  2018    11    22    12     14 "This is my step…        0 2018-11-22
10 Long      2018    11    22    12     18 "It takes guts t…        0 2018-11-22
# ℹ 50 more rows
```
]

---
count: false
 
### Motivating example:&lt;br&gt;Number of messages per day in a WhatsApp chat
.panel1-wa-example-auto[

```r
library(tidyverse)

read_csv("https://long_nguyen.pages.ub.uni-bielefeld.de/dbd-ss23/data/wa-chat.csv") |&gt;
  filter(year == 2018) |&gt;
  mutate(date = as.Date(
    paste(year, month, day, sep = "-")
  )) |&gt;
* summarise(n = n(), .by = c(person, date))
```
]
 
.panel2-wa-example-auto[

```
# A tibble: 20 × 3
   person   date           n
   &lt;chr&gt;    &lt;date&gt;     &lt;int&gt;
 1 Long     2018-11-18     2
 2 Person 2 2018-11-18     1
 3 Person 2 2018-11-20     2
 4 Long     2018-11-20     1
 5 Long     2018-11-22     2
 6 Person 2 2018-11-22     4
 7 Long     2018-11-29     1
 8 Person 2 2018-11-29     1
 9 Person 2 2018-12-09     3
10 Long     2018-12-09     2
11 Long     2018-12-16     2
12 Person 2 2018-12-16     1
13 Long     2018-12-20    11
14 Person 2 2018-12-20     8
15 Long     2018-12-21     2
16 Person 2 2018-12-21     1
17 Person 2 2018-12-23     7
18 Long     2018-12-23     6
19 Long     2018-12-28     2
20 Person 2 2018-12-28     1
```
]

---
count: false
 
### Motivating example:&lt;br&gt;Number of messages per day in a WhatsApp chat
.panel1-wa-example-auto[

```r
library(tidyverse)

read_csv("https://long_nguyen.pages.ub.uni-bielefeld.de/dbd-ss23/data/wa-chat.csv") |&gt;
  filter(year == 2018) |&gt;
  mutate(date = as.Date(
    paste(year, month, day, sep = "-")
  )) |&gt;
  summarise(n = n(), .by = c(person, date)) |&gt;
* ggplot(aes(x = date, y = n, fill = person))
```
]
 
.panel2-wa-example-auto[
&lt;img src="data-collection-1_files/figure-html/wa-example_auto_06_output-1.png" width="100%" style="display: block; margin: auto;" /&gt;
]

---
count: false
 
### Motivating example:&lt;br&gt;Number of messages per day in a WhatsApp chat
.panel1-wa-example-auto[

```r
library(tidyverse)

read_csv("https://long_nguyen.pages.ub.uni-bielefeld.de/dbd-ss23/data/wa-chat.csv") |&gt;
  filter(year == 2018) |&gt;
  mutate(date = as.Date(
    paste(year, month, day, sep = "-")
  )) |&gt;
  summarise(n = n(), .by = c(person, date)) |&gt;
  ggplot(aes(x = date, y = n, fill = person)) +
* geom_col(position = "dodge")
```
]
 
.panel2-wa-example-auto[
&lt;img src="data-collection-1_files/figure-html/wa-example_auto_07_output-1.png" width="100%" style="display: block; margin: auto;" /&gt;
]

&lt;style&gt;
.panel1-wa-example-auto {
  color: black;
  width: 54.4444444444444%;
  hight: 32%;
  float: left;
  padding-left: 1%;
  font-size: 80%
}
.panel2-wa-example-auto {
  color: black;
  width: 43.5555555555556%;
  hight: 32%;
  float: left;
  padding-left: 1%;
  font-size: 80%
}
.panel3-wa-example-auto {
  color: black;
  width: NA%;
  hight: 33%;
  float: left;
  padding-left: 1%;
  font-size: 80%
}
&lt;/style&gt;





---
class: inverse center middle

# Getting familiar with R and RStudio

---

### R, RStudio

- **R**: the programming language

  &lt;img src="https://cran.rstudio.com/Rlogo.svg" height=40&gt;

--

- **RStudio**: the integrated development environment (IDE)

  &lt;img src="https://www.rstudio.com/wp-content/uploads/2018/10/RStudio-Logo-flat.svg" height=40&gt;

--

👉 Use **RStudio** to write, save, and run **R** code

---

### Start R with a blank state

.pull-left[
**Tools** → **Global Options**:

  &lt;img src="https://rstats.wtf/img/rstudio-workspace.png" height=400&gt;  
  .smaller[(Source: https://rstats.wtf/source-and-blank-slates.html)]
]

--

.pull-right[
#### Why?

- A polluted workspace can make your workflow unreproducible

- The code and data needed to reproduce your workflow are saved explicitly anyway
]

---

### Use RStudio Projects

.pull-left[
1) **File** → **New Project...**

  &lt;img src="http://www.rstudio.com/images/docs/projects_new.png" height=280&gt;  
  .smaller[(Source: https://support.posit.co/hc/en-us/articles/200526207-Using-Projects)]

2) **New Directory** → **New Project**
]
--

.pull-right[
#### Why?

- Data management: everything needed (code, data, and files) is in one single, organised directory

- Workspace management: project-specific **working directory**; no need for `setwd("path/that/only/works/on/my/machine")`

  &lt;img src="https://evalsp23.classes.andrewheiss.com/files/img/example/working-directory.png" height=60&gt;

- Reproducibility: share your code and data with others more easily
]

---

### Further readings

- [_What They Forgot to Teach You About R_](https://rstats.wtf/) by Jenny Bryan et al., Chapter 1–4

---
class: inverse center middle

# R programming basics

---
class: inverse center middle

## Functions

---

### Call a function

- Calculate the square root of 69420

--


```r
sqrt(69420)
```

```
[1] 263.4768
```

--

- Write "data" in UPPERCASE

--


```r
toupper("data")
```

```
[1] "DATA"
```

---

### Help pages

```r
?sqrt
```

--

```
Miscellaneous Mathematical Functions

Description:

     'abs(x)' computes the absolute value of x, 'sqrt(x)' computes the
     (principal) square root of x, sqrt{x}.

     The naming follows the standard for computer languages such as C
     or Fortran.

Usage:

     abs(x)
     sqrt(x)
     
Arguments:

       x: a numeric or 'complex' vector or array.
```

---

### Function arguments

```r
?sum
```

```
Sum of Vector Elements

Description:

     'sum' returns the sum of all the values present in its arguments.

Usage:

     sum(..., na.rm = FALSE)
     
Arguments:

     ...: numeric or complex or logical vectors.

   na.rm: logical.  Should missing values (including 'NaN') be removed?
```

--

- `na.rm` is an optional argument: comes with a default value (`FALSE`)

---

### Function arguments

`rnorm()` is a function that generates random numbers from a normal distribution. Fix the error in the code below:

```r
rnorm(10, mu = 100, sd = 50)
```

---
class: inverse center middle

## Objects

---

### Creating an object

- In R you save results by creating an object

- Use the assignment operator (`&lt;-`) to store a value in an object:


```r
magic_number &lt;- sqrt(69420)
```

--

### Using an object


```r
magic_number
```

```
[1] 263.4768
```


```r
another_number &lt;- magic_number
another_number ^ 100
```

```
[1] 1.186398e+242
```

---
class: inverse center middle

## Vectors

---

### Vectors

- R stores every value as a vector

- A single value, e.g. `1`, is actually a vector of length one

---

### Creating a vector

- `c()` function combines values into a single vector:


```r
c(1, 2, 3)
```

```
[1] 1 2 3
```

--

- Use the `:` shortcut to create a vector of continuous integers


```r
1:10
```

```
 [1]  1  2  3  4  5  6  7  8  9 10
```

---

### Subsetting vector


```r
my_vec &lt;- c(1, 2, 4, 8, 16)
```

--

- Extract the fourth element of `my_vec`:


```r
my_vec[4]
```

```
[1] 8
```

--

- Use a vector to extract the multiple elements of `my_vec`:


```r
my_vec[c(1, 2, 5)]
```

```
[1]  1  2 16
```

---
class: inverse center middle

## Data types

---

### Basic types

- **Atomic vectors**: every value is of the same type

  - `logical`: `c(TRUE, FALSE, NA)`

--

  - `numeric`&lt;sup class="smaller"&gt;[*]&lt;/sup&gt;: `c(3.14, 42, NA_real_)`

--

  - `character`: `c("Germany", "France", NA_character_)`

--

- `function`

--

- `list` (generic vector): can store elements of mixed types


```r
list("a", 1:3)
```

```
[[1]]
[1] "a"

[[2]]
[1] 1 2 3
```

---

### Compound types (examples)

- `data.frame`


```r
mtcars
```

```
                   mpg cyl disp  hp drat    wt  qsec vs am gear carb
Mazda RX4         21.0   6  160 110 3.90 2.620 16.46  0  1    4    4
Mazda RX4 Wag     21.0   6  160 110 3.90 2.875 17.02  0  1    4    4
Datsun 710        22.8   4  108  93 3.85 2.320 18.61  1  1    4    1
Hornet 4 Drive    21.4   6  258 110 3.08 3.215 19.44  1  0    3    1
Hornet Sportabout 18.7   8  360 175 3.15 3.440 17.02  0  0    3    2
 [ reached 'max' / getOption("max.print") -- omitted 27 rows ]
```

--

- `Date`


```r
as.Date("2023-04-20") + 1
```

```
[1] "2023-04-21"
```

---
class: inverse center middle

## Packages

---

### Loading packages

- At startup, R loads only a core set of functions and objects, known as **Base R**

- Other functions and objects are stored in collections known as **packages**

- To use these external functions, you must first load the package they come in with the `library()` function:

```r
library(tidyverse)
```

---

### Loading packages

What does this common error message suggest?

`object _____ does not exist.`

---

### Installing packages

```r
install.packages("tidyverse")
```

---
class: inverse center middle

# Working with data using **tidyverse**

---
class: inverse center middle

## Importing data

---

### CSV files

- CSV: comma-separated values

- Header row: column names

- Following rows: data

--

#### Example CSV file

👉 https://long_nguyen.pages.ub.uni-bielefeld.de/dbd-ss23/data/wa-chat.csv


```
person,year,month,day,hour,minute,message,n_emojis
Long,2018,11,18,17,52,They tried to make a diamond shaped like a duck. It quacked under the pressure.,0
Long,2018,11,18,17,53,https://www.why-does-norway-have-barcodes-on-their-battleships-so-when-they-get-back-to-port-they-can-scandinavian.com,0
Person 2,2018,11,18,18,51,"Why do pirates not know the alphabet? They always get stuck at ""C"". 😊",1
Person 2,2018,11,20,17,6,"Some people say that I never got over my obsession with Phil Collins.
...
```

.smaller[(Source for jokes: https://icanhazdadjoke.com/)]

---

### Reading data from a CSV file


```r
chat &lt;- read_csv("https://long_nguyen.pages.ub.uni-bielefeld.de/dbd-ss23/data/wa-chat.csv")

chat
```


```
# A tibble: 2,192 × 8
  person    year month   day  hour minute message                       n_emojis
  &lt;chr&gt;    &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt; &lt;chr&gt;                            &lt;dbl&gt;
1 Long      2018    11    18    17     52 "They tried to make a diamon…        0
2 Long      2018    11    18    17     53 "https://www.why-does-norway…        0
3 Person 2  2018    11    18    18     51 "Why do pirates not know the…        1
4 Person 2  2018    11    20    17      6 "Some people say that I neve…        0
5 Person 2  2018    11    20    17      7 "Why did Sweden start painti…        0
6 Long      2018    11    20    17      7 "It takes guts to be an orga…        1
# ℹ 2,186 more rows
```

---
class: inverse middle center

## Extracting variables and cases

---

### `select()`: Extracting columns

- First argument (`.data`): name of a data frame

- `...` argument(s): name(s) of the columns to extract – _not_ in quotation marks

--


```r
select(chat, person, hour)
```


```
# A tibble: 2,192 × 2
  person    hour
  &lt;chr&gt;    &lt;dbl&gt;
1 Long        17
2 Long        17
3 Person 2    18
4 Person 2    17
5 Person 2    17
6 Long        17
# ℹ 2,186 more rows
```

---

### `select()`: Extracting columns

- Place a minus sign before a column name to select every column but that column


```r
select(chat, -c(person, message))
```

```
# A tibble: 2,192 × 6
    year month   day  hour minute n_emojis
   &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt;    &lt;dbl&gt;
 1  2018    11    18    17     52        0
 2  2018    11    18    17     53        0
 3  2018    11    18    18     51        1
 4  2018    11    20    17      6        0
 5  2018    11    20    17      7        0
 6  2018    11    20    17      7        1
 7  2018    11    22    12      5        0
 8  2018    11    22    12     14        0
 9  2018    11    22    12     14        0
10  2018    11    22    12     18        0
# ℹ 2,182 more rows
```

---

#### Other `select()` helpers

.pull-left[

```r
select(chat, year:minute)
```


```
# A tibble: 2,192 × 5
   year month   day  hour minute
  &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt;
1  2018    11    18    17     52
2  2018    11    18    17     53
# ℹ 2,190 more rows
```


```r
select(chat, starts_with("m"))
```


```
# A tibble: 2,192 × 3
  month minute message                                                          
  &lt;dbl&gt;  &lt;dbl&gt; &lt;chr&gt;                                                            
1    11     52 They tried to make a diamond shaped like a duck. It quacked unde…
2    11     53 https://www.why-does-norway-have-barcodes-on-their-battleships-s…
# ℹ 2,190 more rows
```
]

.pull-right[

```r
select(chat, ends_with("e"))
```


```
# A tibble: 2,192 × 2
  minute message                                                                
   &lt;dbl&gt; &lt;chr&gt;                                                                  
1     52 They tried to make a diamond shaped like a duck. It quacked under the …
2     53 https://www.why-does-norway-have-barcodes-on-their-battleships-so-when…
# ℹ 2,190 more rows
```


```r
select(chat, contains("ji"))
```


```
# A tibble: 2,192 × 1
  n_emojis
     &lt;dbl&gt;
1        0
2        0
# ℹ 2,190 more rows
```
]

---

### `filter()`: Extracting rows

- First argument (`.data`): name of a data frame

- `...` argument(s): logical test(s)

- Keeps every row for which the tests return `TRUE`

--


```r
filter(chat, person == "Long")
```


```
# A tibble: 1,156 × 8
  person  year month   day  hour minute message                         n_emojis
  &lt;chr&gt;  &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt; &lt;chr&gt;                              &lt;dbl&gt;
1 Long    2018    11    18    17     52 "They tried to make a diamond …        0
2 Long    2018    11    18    17     53 "https://www.why-does-norway-h…        0
3 Long    2018    11    20    17      7 "It takes guts to be an organ …        1
4 Long    2018    11    22    12      5 "What kind of magic do cows be…        0
5 Long    2018    11    22    12     18 "It takes guts to be an organ …        0
6 Long    2018    11    29     0      3 "How many seconds are in a yea…        0
# ℹ 1,150 more rows
```

---

#### Logical tests

|            |                                 |
|:-----------|:--------------------------------|
|`x == y`    |Is x equal to y?                 |
|`x != y`    |Is x not equal to y?             |
|`x &gt; y`     |Is x greater than y?             |
|`x &gt;= y`    |Is x greater than or equal to y? |
|`x &lt; y`     |Is x less than y?                |
|`x &lt;= y`    |Is x less than or equal to y?    |
|`is.na(x)`  |Is x an NA?                      |

---

#### Combining logical tests with boolean operators

|                    |                                         |
|:-------------------|:----------------------------------------|
|`!A`                |Is A not true?                           |
|`A &amp; B`             |Are both A **and** B true?               |
|&lt;span class="remark-inline-code"&gt;A &amp;#124; B&lt;span&gt; |Is A **or** B (or both) true? |
|`xor(A, B)`         |Is **one and only one** of A and B true? |
|`x %in% c(a, b, c)` |Is x **in** the set of a, b, and c?      |
|`any(A, B, C)`      |Are **any** of A, B, or C true?          |
|`all(A, B, C)`      |Are **all** of A, B, and C true?         |

---

#### Exercise

Filter for messages sent on **9 and 10 September 2019**.

---

### `arrange()`: Reordering rows

- First argument (`.data`): name of a data frame

- `...` argument(s): column name(s) – _not_ in quotation marks

- Reorders rows by the values of the column names provided

--


```r
arrange(chat, hour, minute)
```


```
# A tibble: 2,192 × 8
  person    year month   day  hour minute message                       n_emojis
  &lt;chr&gt;    &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt; &lt;chr&gt;                            &lt;dbl&gt;
1 Long      2018    11    29     0      3 "How many seconds are in a y…        0
2 Person 2  2021     7    10     0      4 "I knew i shouldn’t have ate…        1
3 Person 2  2021     7    10     0      4 "What's the difference betwe…        1
4 Person 2  2021     7    10     0      5 "A quick shoutout to all of …        1
5 Person 2  2021     7    10     0      5 "Why did the girl smear pean…        1
6 Long      2019     9    12     0      6 "&lt;Media omitted&gt;"                    0
# ℹ 2,186 more rows
```

---

#### `desc()`: arranging in opposite order


```r
arrange(chat, desc(n_emojis))
```

```
# A tibble: 2,192 × 8
   person    year month   day  hour minute message                      n_emojis
   &lt;chr&gt;    &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt; &lt;chr&gt;                           &lt;dbl&gt;
 1 Person 2  2021     8    19    21     13 "Why was the robot angry? B…        6
 2 Person 2  2018    12    16    18     44 "Did you hear about the cha…        4
 3 Person 2  2018    12    28    16     45 "What did the ocean say to …        4
 4 Person 2  2019     2     7    14      1 "Where do cats write notes?…        4
 5 Person 2  2020     2    19    15      4 "Where do cats write notes?…        4
 6 Long      2020     4    29    17     41 "I've been trying to come u…        4
 7 Person 2  2020     6    19    14     43 "What did the drummer name …        4
 8 Long      2020     7    11    10     39 "In my career as a lumberja…        4
 9 Person 2  2020     9     3    20     41 "I met this girl on a datin…        4
10 Person 2  2021     4    27    15      6 "A book just fell on my hea…        4
# ℹ 2,182 more rows
```

---

### The pipe `|&gt;`

- `tidyverse` functions are easy to use in a step-by-step fashion:


```r
chat_late &lt;- filter(chat, hour &gt; 22 | hour &lt; 6)
chat_late &lt;- select(chat_late, person, year:minute)
chat_late &lt;- arrange(chat_late, hour)
```


```r
chat_late
```


```
# A tibble: 101 × 6
  person    year month   day  hour minute
  &lt;chr&gt;    &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt;
1 Long      2018    11    29     0      3
2 Long      2019     1    18     0     14
3 Person 2  2019     1    18     0     28
# ℹ 98 more rows
```

--

→ inefficient way to write code

---

### The pipe `|&gt;`

- One way to avoid redundancy:

```r
arrange(select(filter(chat, hour &gt; 22 | hour &lt; 6), person, year:minute), hour)
```

--

😵

---

### The pipe `|&gt;`


```r
chat |&gt;
  filter(hour &gt; 22 | hour &lt; 6) |&gt;
  select(person, year:minute) |&gt;
  arrange(hour)
```


```
# A tibble: 101 × 6
  person    year month   day  hour minute
  &lt;chr&gt;    &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;  &lt;dbl&gt;
1 Long      2018    11    29     0      3
2 Long      2019     1    18     0     14
3 Person 2  2019     1    18     0     28
4 Long      2019     9    12     0      6
5 Person 2  2020     6    28     0      6
6 Person 2  2020     6    28     0      6
# ℹ 95 more rows
```

---

### The pipe `|&gt;`

`x |&gt; f(y)` is equivalent to `f(x, y)`

--

&lt;br&gt;

This:

```r
thing |&gt;
  firstly_do(something) |&gt;
  secondly_do(something) |&gt;
  thirdly_do(something)
```

is equivalent to this:

```r
thirdly_do(secondly_do(firstly_do(thing, something), something), something)
```

---
class: inverse center middle

## Deriving information

---

### `summarise()`:&lt;br&gt;Calculating single value out of multiple rows

Each named argument is set to an R expression that generates **a single value** → turned into a column in the new data frame

--


```r
chat |&gt;
  filter(year == 2021) |&gt;
  summarise(total = sum(n_emojis), max = max(n_emojis), mean = mean(n_emojis))
```

```
# A tibble: 1 × 3
  total   max  mean
  &lt;dbl&gt; &lt;dbl&gt; &lt;dbl&gt;
1   537     6 0.547
```

---

#### Summary functions


- Measures of location: `mean(x)`, `median(x)`, `quantile(x, 0.25)`, `min(x)`, `max(x)`

--

- Measures of spread: `var(x)`, `sd(x)`, `mad(x)`, `IQR(x)`

--

- Measures of position: `first(x)`, `nth(x, 2)`, `last(x)`

--

- Counts: `n()`, `n_distinct(x)`

--

- Counts and proportions of logical values:

  - `sum(x == y)`: number of `TRUE`s returned by a logical test
  
  - `mean(x == y)`: proportion of `TRUE`s returned by a logical test

---

#### Exercise

- How many years are there in the chat?

--

- What proportion of messages has at least one emoji?

--

- When was the last message sent by Person 2?

---

### `summarise(.by = &lt;group of rows&gt;)`

.pull-left[

```r
chat |&gt;
  mutate(timestamp = as_datetime(
    paste(year, month, day, hour, minute),
    format = "%Y %m %d %H %M"
  )) |&gt;
  summarise(
    last = max(timestamp)
  )
```
]

.pull-right[

```
# A tibble: 1 × 1
  last               
  &lt;dttm&gt;             
1 2023-04-19 00:12:00
```
]

---

### `summarise(.by = &lt;group of rows&gt;)`

.pull-left[

```r
chat |&gt;
  mutate(timestamp = as_datetime(
    paste(year, month, day, hour, minute),
    format = "%Y %m %d %H %M"
  )) |&gt;
  summarise(
    last = max(timestamp),
*   .by = person
  )
```
]

.pull-right[

```
# A tibble: 2 × 2
  person   last               
  &lt;chr&gt;    &lt;dttm&gt;             
1 Long     2023-04-19 00:12:00
2 Person 2 2023-04-18 23:18:00
```
]

--

- `.by` takes column name(s) (like `select()` and `arrange()`)

- Each group is a set of rows that share identical combinations of values in the specified columns

---

### `summarise(.by = &lt;group of rows&gt;)`

.pull-left[

```r
chat |&gt;
  mutate(timestamp = as_datetime(
    paste(year, month, day, hour, minute),
    format = "%Y %m %d %H %M"
  )) |&gt;
  summarise(
    last = max(timestamp),
*   .by = c(person, year)
  )
```
]

.pull-right[

```
# A tibble: 12 × 3
   person    year last               
   &lt;chr&gt;    &lt;dbl&gt; &lt;dttm&gt;             
 1 Long      2018 2018-12-28 15:44:00
 2 Person 2  2018 2018-12-28 16:45:00
 3 Long      2019 2019-10-16 22:02:00
 4 Person 2  2019 2019-10-17 07:20:00
 5 Person 2  2020 2020-12-15 17:44:00
 6 Long      2020 2020-12-15 17:57:00
 7 Long      2021 2021-12-03 22:21:00
 8 Person 2  2021 2021-12-03 22:23:00
 9 Long      2022 2022-12-01 09:20:00
10 Person 2  2022 2022-12-01 08:11:00
11 Long      2023 2023-04-19 00:12:00
12 Person 2  2023 2023-04-18 23:18:00
```
]

---

#### Exercise

- How many messages did each person send?

- What proportion of messages did I send each year?

---

### `mutate()`:&lt;br&gt;Creating columns that are functions of existing ones

- Syntax similar to `summarise()`, but the expression in each named argument should return either **n values**, where n is the **number of rows**, or **a single value**

- Output data frame has the same number of rows as input data frame

--


```r
chat |&gt;
  summarise(prop = mean(person == "Long"), .by = year) |&gt;
* mutate(percent = round(prop * 100, 1))
```

```
# A tibble: 6 × 3
   year  prop percent
  &lt;dbl&gt; &lt;dbl&gt;   &lt;dbl&gt;
1  2018 0.517    51.7
2  2019 0.572    57.2
3  2020 0.512    51.2
4  2021 0.515    51.5
5  2022 0.491    49.1
6  2023 0.556    55.6
```

---

#### Vectorised functions

Take vectors of input and **return vectors** of values

Examples:

- Arithmetic operators: `+`, `-`, `*`, `/`, `^`

- Modular arithmetic: `%/%` (integer division), `%%` (remainder)

- Logical comparisons: `&lt;`, `&lt;=`, `&gt;`, `&gt;=`, `!=`

- Logarithms: `log(x)`, `log2(x)`, `log10(x)`

- Offsets: `lead(x)`, `lag(x)`

- Cumulative aggregates: `cumsum(x)`, `cumprod(x)`, `cummin(x)`, `cummax(x)`, `cummean(x)`

- Ranking: `row_number(x)`, `min_rank(x)`, `dense_rank(x)`

---

#### Exercise

When did each person reach 100 emojis?

(Hint: `mutate()` also has a `.by` argument)

---

## Assignment

1. Write an R script that answers all the exercise questions in the slides (there should be 7 questions).

2. At the end of this script, think of a question that can be answered by combining at least 4 of the 5 functions `select()`, `arrange()`, `filter`, `mutate()`, and `summarise()` – then write the code to answer it.
    </textarea>
<style data-target="print-only">@media screen {.remark-slide-container{display:block;}.remark-slide-scaler{box-shadow:none;}}</style>
<script src="https://remarkjs.com/downloads/remark-latest.min.js"></script>
<script>var slideshow = remark.create({
"highlightStyle": "github",
"highlightLines": true,
"ratio": "16:9",
"countIncrementalSlides": false
});
if (window.HTMLWidgets) slideshow.on('afterShowSlide', function (slide) {
  window.dispatchEvent(new Event('resize'));
});
(function(d) {
  var s = d.createElement("style"), r = d.querySelector(".remark-slide-scaler");
  if (!r) return;
  s.type = "text/css"; s.innerHTML = "@page {size: " + r.style.width + " " + r.style.height +"; }";
  d.head.appendChild(s);
})(document);

(function(d) {
  var el = d.getElementsByClassName("remark-slides-area");
  if (!el) return;
  var slide, slides = slideshow.getSlides(), els = el[0].children;
  for (var i = 1; i < slides.length; i++) {
    slide = slides[i];
    if (slide.properties.continued === "true" || slide.properties.count === "false") {
      els[i - 1].className += ' has-continuation';
    }
  }
  var s = d.createElement("style");
  s.type = "text/css"; s.innerHTML = "@media print { .has-continuation { display: none; } }";
  d.head.appendChild(s);
})(document);
// delete the temporary CSS (for displaying all slides initially) when the user
// starts to view slides
(function() {
  var deleted = false;
  slideshow.on('beforeShowSlide', function(slide) {
    if (deleted) return;
    var sheets = document.styleSheets, node;
    for (var i = 0; i < sheets.length; i++) {
      node = sheets[i].ownerNode;
      if (node.dataset["target"] !== "print-only") continue;
      node.parentNode.removeChild(node);
    }
    deleted = true;
  });
})();
// add `data-at-shortcutkeys` attribute to <body> to resolve conflicts with JAWS
// screen reader (see PR #262)
(function(d) {
  let res = {};
  d.querySelectorAll('.remark-help-content table tr').forEach(tr => {
    const t = tr.querySelector('td:nth-child(2)').innerText;
    tr.querySelectorAll('td:first-child .key').forEach(key => {
      const k = key.innerText;
      if (/^[a-z]$/.test(k)) res[k] = t;  // must be a single letter (key)
    });
  });
  d.body.setAttribute('data-at-shortcutkeys', JSON.stringify(res));
})(document);
(function() {
  "use strict"
  // Replace <script> tags in slides area to make them executable
  var scripts = document.querySelectorAll(
    '.remark-slides-area .remark-slide-container script'
  );
  if (!scripts.length) return;
  for (var i = 0; i < scripts.length; i++) {
    var s = document.createElement('script');
    var code = document.createTextNode(scripts[i].textContent);
    s.appendChild(code);
    var scriptAttrs = scripts[i].attributes;
    for (var j = 0; j < scriptAttrs.length; j++) {
      s.setAttribute(scriptAttrs[j].name, scriptAttrs[j].value);
    }
    scripts[i].parentElement.replaceChild(s, scripts[i]);
  }
})();
(function() {
  var links = document.getElementsByTagName('a');
  for (var i = 0; i < links.length; i++) {
    if (/^(https?:)?\/\//.test(links[i].getAttribute('href'))) {
      links[i].target = '_blank';
    }
  }
})();
// adds .remark-code-has-line-highlighted class to <pre> parent elements
// of code chunks containing highlighted lines with class .remark-code-line-highlighted
(function(d) {
  const hlines = d.querySelectorAll('.remark-code-line-highlighted');
  const preParents = [];
  const findPreParent = function(line, p = 0) {
    if (p > 1) return null; // traverse up no further than grandparent
    const el = line.parentElement;
    return el.tagName === "PRE" ? el : findPreParent(el, ++p);
  };

  for (let line of hlines) {
    let pre = findPreParent(line);
    if (pre && !preParents.includes(pre)) preParents.push(pre);
  }
  preParents.forEach(p => p.classList.add("remark-code-has-line-highlighted"));
})(document);</script>

<script>
slideshow._releaseMath = function(el) {
  var i, text, code, codes = el.getElementsByTagName('code');
  for (i = 0; i < codes.length;) {
    code = codes[i];
    if (code.parentNode.tagName !== 'PRE' && code.childElementCount === 0) {
      text = code.textContent;
      if (/^\\\((.|\s)+\\\)$/.test(text) || /^\\\[(.|\s)+\\\]$/.test(text) ||
          /^\$\$(.|\s)+\$\$$/.test(text) ||
          /^\\begin\{([^}]+)\}(.|\s)+\\end\{[^}]+\}$/.test(text)) {
        code.outerHTML = code.innerHTML;  // remove <code></code>
        continue;
      }
    }
    i++;
  }
};
slideshow._releaseMath(document);
</script>
<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
(function () {
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.src  = 'https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-MML-AM_CHTML';
  if (location.protocol !== 'file:' && /^https?:/.test(script.src))
    script.src  = script.src.replace(/^https?:/, '');
  document.getElementsByTagName('head')[0].appendChild(script);
})();
</script>
  </body>
</html>
